%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define with_gui 1
%define with_python 0

Name: ecryptfs-utils
Version: 75
Release: 5%{?dist}.2
Summary: The eCryptfs mount helper and support libraries
Group: System Environment/Base
License: GPLv2+
URL: http://launchpad.net/ecryptfs
Source0: http://launchpad.net/ecryptfs/trunk/%{version}/+download/%{name}_%{version}.orig.tar.gz
Source1: ecryptfs-utils.png

Patch1: ecryptfs-utils-mount-helper-gui.patch

#fix wrong Makefile for umount.ecryptfs and Werror
Patch2: ecryptfs-utils-74-build.patch

#restrict suid mount.ecryptfs_private to ecryptfs group only
#required for ecryptfs-utils <=75
Patch3: ecryptfs-utils-74-group.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#499128
Patch4: ecryptfs-utils-75-opensslpasswd.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#499367
Patch5: ecryptfs-utils-75-indef.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#499167
Patch6: ecryptfs-utils-75-rmenokey.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500361
Patch7: ecryptfs-utils-75-keyexists.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#499175
Patch8: ecryptfs-utils-75-nosmallrsa.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500352, rhbz#501275
Patch9: ecryptfs-utils-75-checkkeysize.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500566
Patch10: ecryptfs-utils-75-fnekerrno.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500850
Patch11: ecryptfs-utils-75-verifypass.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500813
Patch12: ecryptfs-utils-75-erf.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500810
Patch13: ecryptfs-utils-75-keyexists2.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#500804
Patch14: ecryptfs-utils-75-erfmantypo.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#501460
Patch15: ecryptfs-utils-75-keyringfull.patch

#taken from upstream, required for ecryptfs-utils <= 75, rhbz#500820
Patch16: ecryptfs-utils-75-blkid.patch

#rhbz#500829
Patch17: ecryptfs-utils-75-nocryptdisks.patch

#sent upstream, required for ecryptfs-utils <= 75, rhbz#499367
Patch18: ecryptfs-utils-75-eof.patch

# CVE-2011-1831, CVE-2011-1832, CVE-2011-1833, CVE-2011-1834, CVE-2011-1835, CVE-2011-1837
# for ecryptfs-utils < 90, rhbz#729465
Patch19: ecryptfs-utils-82-multicve.patch

#for e-u <= 90
Patch20: ecryptfs-utils-82-CVE-2011-3145.patch

BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: keyutils, cryptsetup-luks, e2fsprogs
BuildRequires: libgcrypt-devel keyutils-libs-devel openssl-devel pam-devel
BuildRequires: trousers-devel nss-devel desktop-file-utils

%description
eCryptfs is a stacked cryptographic filesystem that ships in the
Linux kernel. This package provides the mount helper and supporting
libraries to perform key management and mount functions.

Install ecryptfs-utils if you would like to mount eCryptfs.

%if "%{with_gui}" == "1"
%package gui
Summary: The eCryptfs userspace graphical mount helper tool
Group: System Environment/Base 
Requires: %{name} = %{version}-%{release}
Requires: pygtk2 >= 2.6, usermode, pygtk2-libglade
BuildRequires: python python-devel

%description gui
A pygtk-based graphical mount helper tool for eCryptfs overlay mounts
%endif

%package devel
Summary: The eCryptfs userspace development package
Group: System Environment/Base
Requires: keyutils-libs-devel %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
Userspace development files for eCryptfs.

%if "%{with_python}" == "1"
%package python
Summary: Python bindings for the eCryptfs utils
Group: System Environment/Base
Requires: ecryptfs-utils %{name} = %{version}-%{release}
BuildRequires: python python-devel swig >= 1.3.31

%description python
The ecryptfs-utils-python package contains a module that permits 
applications written in the Python programming language to use 
the interface supplied by the ecryptfs-utils library.
%endif

%prep
%setup -q
%if "%{with_gui}" == "1"
%patch1 -p1 -b .gui
%endif
%patch2 -p1 -b .build
%patch3 -p1 -b .group
%patch4 -p0 -b .opensslpasswd
%patch5 -p0 -b .indef
%patch6 -p0 -b .rmenokey
%patch7 -p0 -b .nosmallrsa
%patch8 -p0 -b .keyexists
%patch9 -p0 -b .checkkeysize
%patch10 -p0 -b .fnekerrno
%patch11 -p0 -b .verifypass
%patch12 -p0 -b .erf
%patch13 -p0 -b .keyexists2
%patch14 -p0 -b .erfmantypo
%patch15 -p0 -b .keyringfull
%patch16 -p0 -b .blkid
%patch17 -p0 -b .nocryptdisks
%patch18 -p0 -b .eof
%patch19 -p1 -b .multicve
%patch20 -p1 -b .cve20113145

%build
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -ggdb -O2"
%configure --disable-rpath --enable-tspi --enable-nss --enable-static --disable-opencryptoki
make clean
#disable rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
#remove -Werror flag for swig temporarily (swig is nasty #496613)
sed -i 's|-Werror||' src/libecryptfs-swig/Makefile
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT%{_libdir}/ -name '*.a' | xargs rm -f
find $RPM_BUILD_ROOT%{_libdir}/ -name '*.la' | xargs rm -f
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}
#install files Makefile forgot install
install -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-utils.png
printf "Encoding=UTF-8\n" >>$RPM_BUILD_ROOT/%{_datadir}/%{name}/ecryptfs-mount-private.desktop
printf "Encoding=UTF-8\n" >>$RPM_BUILD_ROOT/%{_datadir}/%{name}/ecryptfs-setup-private.desktop
printf "Icon=%{_datadir}/%{name}/ecryptfs-utils.png\n" >>$RPM_BUILD_ROOT/%{_datadir}/%{name}/ecryptfs-mount-private.desktop
printf "Icon=%{_datadir}/%{name}/ecryptfs-utils.png\n" >>$RPM_BUILD_ROOT/%{_datadir}/%{name}/ecryptfs-setup-private.desktop
desktop-file-validate $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-mount-private.desktop
desktop-file-validate $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-setup-private.desktop
chmod +x $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-mount-private.desktop
chmod +x $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-setup-private.desktop
touch -r src/desktop/ecryptfs-mount-private.desktop \
     $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-mount-private.desktop
touch -r src/desktop/ecryptfs-setup-private.desktop \
     $RPM_BUILD_ROOT%{_datadir}/%{name}/ecryptfs-mount-private.desktop
rm -f $RPM_BUILD_ROOT/%{_datadir}/%{name}/ecryptfs-record-passphrase

#ecryptfs-dot-private should be only sourced, not executed (#500817)
chmod -x $RPM_BUILD_ROOT%{_bindir}/ecryptfs-dot-private

# gui bits (really needs Makefile integration...)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}

%if "%{with_gui}" == "1"
  mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/security/console.apps/
  mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/
  install -p -m644 src/utils/ecryptfs-mount-helper-gui.glade $RPM_BUILD_ROOT%{_datadir}/%{name}/
  install -p -m755 src/utils/ecryptfs-mount-helper-gui.py $RPM_BUILD_ROOT%{_datadir}/%{name}/
  install -p -m644 src/utils/ecryptfs-mount-helper-gui.console $RPM_BUILD_ROOT%{_sysconfdir}/security/console.apps/ecryptfs-mount-helper-gui
  ln -s consolehelper $RPM_BUILD_ROOT%{_bindir}/ecryptfs-mount-helper-gui
  desktop-file-install --vendor system --delete-original      \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications             \
    --add-category X-Red-Hat-Base                             \
    src/utils/ecryptfs-mount-helper-gui.desktop
  install -p -m644 src/utils/ecryptfs-mount-helper-gui.pam $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/ecryptfs-mount-helper-gui
%endif

%if "%{with_python}" != "1"
rm -rf $RPM_BUILD_ROOT%{_libdir}/python*
rm -rf $RPM_BUILD_ROOT/usr/lib/python*
%endif

%pre
groupadd -r -f ecryptfs

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%if "%{with_gui}" == "1"
%post gui
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi

%postun gui
touch --no-create %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  gtk-update-icon-cache -q %{_datadir}/icons/hicolor
fi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc README COPYING AUTHORS NEWS THANKS
%doc doc/ecryptfs-faq.html doc/ecryptfs-pam-doc.txt
/sbin/mount.ecryptfs
/sbin/umount.ecryptfs
%attr(4750,root,ecryptfs) /sbin/mount.ecryptfs_private
/sbin/umount.ecryptfs_private
%{_bindir}/ecryptfs-manager
%{_bindir}/ecryptfs-insert-wrapped-passphrase-into-keyring
%{_bindir}/ecryptfs-rewrap-passphrase
%{_bindir}/ecryptfs-rewrite-file
%{_bindir}/ecryptfs-unwrap-passphrase
%{_bindir}/ecryptfs-wrap-passphrase
%{_bindir}/ecryptfs-add-passphrase
%{_bindir}/ecryptfs-generate-tpm-key
%{_bindir}/ecryptfs-mount-private
%{_bindir}/ecryptfs-setup-private
%{_bindir}/ecryptfs-setup-swap
%{_bindir}/ecryptfs-umount-private
%{_bindir}/ecryptfs-stat
%{_bindir}/ecryptfsd
%{_bindir}/ecryptfs-dot-private
%{_libdir}/ecryptfs
%{_libdir}/libecryptfs.so.0
%{_libdir}/libecryptfs.so.0.0.0
/%{_lib}/security/pam_ecryptfs.so
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/ecryptfs-mount-private.txt
%{_datadir}/%{name}/ecryptfs-mount-private.desktop
%{_datadir}/%{name}/ecryptfs-setup-private.desktop
%{_datadir}/%{name}/ecryptfs-utils.png
%{_mandir}/man1/ecryptfs-add-passphrase.1.gz
%{_mandir}/man1/ecryptfs-generate-tpm-key.1.gz
%{_mandir}/man1/ecryptfs-insert-wrapped-passphrase-into-keyring.1.gz
%{_mandir}/man1/ecryptfs-mount-private.1.gz
%{_mandir}/man1/ecryptfs-rewrap-passphrase.1.gz
%{_mandir}/man1/ecryptfs-rewrite-file.1.gz
%{_mandir}/man1/ecryptfs-setup-private.1.gz
%{_mandir}/man1/ecryptfs-umount-private.1.gz
%{_mandir}/man1/ecryptfs-unwrap-passphrase.1.gz
%{_mandir}/man1/ecryptfs-wrap-passphrase.1.gz
%{_mandir}/man1/mount.ecryptfs_private.1.gz
%{_mandir}/man1/umount.ecryptfs_private.1.gz
%{_mandir}/man7/ecryptfs.7.gz
%{_mandir}/man8/ecryptfs-manager.8.gz
%{_mandir}/man8/ecryptfsd.8.gz
%{_mandir}/man8/mount.ecryptfs.8.gz
%{_mandir}/man8/pam_ecryptfs.8.gz

%if "%{with_gui}" == "1"
%files gui
%defattr(-,root,root,-)
%exclude %{_datadir}/%{name}/*.pyc
%exclude %{_datadir}/%{name}/*.pyo
%{_datadir}/%{name}/*.glade
%{_datadir}/%{name}/*.py
%{_bindir}/ecryptfs-mount-helper-gui
%{_datadir}/applications/*.desktop
%config(noreplace) %{_sysconfdir}/security/console.apps/ecryptfs-mount-helper-gui
%config(noreplace) %{_sysconfdir}/pam.d/ecryptfs-mount-helper-gui
%endif

%files devel
%defattr(-,root,root,-)
%{_libdir}/libecryptfs.so
%{_libdir}/pkgconfig/libecryptfs.pc
%{_includedir}/ecryptfs.h

%if "%{with_python}" == "1"
%files python
%defattr(-,root,root,-)
%dir %{python_sitelib}/ecryptfs-utils
%{python_sitelib}/ecryptfs-utils/libecryptfs.py
%{python_sitelib}/ecryptfs-utils/libecryptfs.pyc
%{python_sitelib}/ecryptfs-utils/libecryptfs.pyo
%dir %{python_sitearch}/ecryptfs-utils
%{python_sitearch}/ecryptfs-utils/_libecryptfs.so.0
%{python_sitearch}/ecryptfs-utils/_libecryptfs.so.0.0.0
%{python_sitearch}/ecryptfs-utils/_libecryptfs.so
%endif

%changelog
* Tue Aug 23 2011 Michal Hlavinka <mhlavink@redhat.com> - 75-5.2
- do not forget to set the group id in mount.ecryptfs_private

* Thu Aug 11 2011 Michal Hlavinka <mhlavink@redhat.com> - 75-5.1
- security fixes:
- privilege escalation via mountpoint race conditions (CVE-2011-1831, CVE-2011-1832)
- race condition when checking source during mount (CVE-2011-1833)
- mtab corruption via improper handling (CVE-2011-1834)
- key poisoning via insecure temp directory handling (CVE-2011-1835)
- arbitrary file overwrite via lock counter race (CVE-2011-1837)

* Mon Jun 02 2009 Michal Hlavinka <mhlavink@redhat.com> 75-5
- add icon to gui

* Mon Jun 01 2009 Michal Hlavinka <mhlavink@redhat.com> 75-4
- fix EOF handling (#499367)
- add icon to gui desktop file

* Tue May 19 2009 Michal Hlavinka <mhlavink@redhat.com> 75-3
- ask for password confirmation when creating openssl key (#500850)
- removed executable permission from ecryptfs-dot-private (#500817)
- ecryptfs-rewrite-file: improve of progress output (#500813)
- don't error out when unwrapping and adding a key that already exists (#500810)
- fix typo in ecryptfs-rewrite-file(1) (#500804)
- add error message about full keyring (#501460)
- gui sub-package must requires pygtk2-libglade (#500997)
- require cryptsetup-luks for encrypted swap (#500824)
- use blkid instead of vol_id (#500820)
- don't rely on cryptdisks service (#500829)

* Thu May 14 2009 Michal Hlavinka <mhlavink@redhat.com> 75-2
- don't hang when used with wrong/missing stdin (#499367)
- don't print error when key already removed (#499167)
- refuse mounting with too small rsa key (#499175)
- don't error out when adding key that already exists (#500361)
- allow only working key sizes (#500352)
- retutn nonzero when fnek is not supported (#500566)
- add icon for Access-Your-Private-Data.desktop file (#500623)
- fix information about openssl_passwd in openssl_passwd_file (#499128)
- don't list mount.ecryptfs_private twice

* Mon May 04 2009 Michal Hlavinka <mhlavink@redhat.com> 75-1
- update to 75 and drop some patches

* Thu Apr 30 2009 Michal Hlavinka <mhlavink@redhat.com> 74-24
- add suid mount.ecryptfs_private, restrict it to ecryptfs group

* Wed Apr 24 2009 Michal Hlavinka <mhlavink@redhat.com> 74-23
- skip releases -2 - -22 to be sure it's always newer nvr

* Wed Apr 24 2009 Michal Hlavinka <mhlavink@redhat.com> 74-22
- drop setuid for mount.ecryptfs_private 
- resolves: #482834

* Thu Apr 23 2009 Michal Hlavinka <mhlavink@redhat.com> 74-1
- update to 74
- fix difference between apps. real names and names in usage messages (#475969)
- describe verobse and verbosity=X in man page (#470444)
- adding passphrase to keyring is fixed (#469662)
- mount won't fail with wrong/empty input to yes/no questions (#466210)
- try to load modules instead of failing when it's missing (#460496)
- fix wrong return codes (#479429)
- resolves: #482834

* Wed Dec 03 2008 Michal Hlavinka <mhlavink@redhat.com> 56-8
- ecryptfs_parse_packet_length() expects data type size_t, not uint32_t
- Resolves: #473272

* Tue Nov 18 2008 Karsten Hopp <karsten@redhat.com> 56-7
- disable gui

* Wed Oct 29 2008 Karsten Hopp <karsten@redhat.com> 56-6
- add fix for bugzilla #467234

* Wed Oct 29 2008 Karsten Hopp <karsten@redhat.com> 56-5
- fix verbosity=1 commandline parameter (#441822)

* Tue Sep 02 2008 Karsten Hopp <karsten@redhat.com> 56-4
- remove conflicting bytecompiled python files
- add some parameters to ecryptfs manpage

* Tue Aug 26 2008 Karsten Hopp <karsten@redhat.com> 56-3
- fix CFLAGS, remove static libs, -devel needs to requires pkgconfig (mnovak)
- fix openssl parameter checks (Eric Sandeen)
- Add mount helper gui (#445733, Jarod Wilson)
- Add missing BR: desktop-file-utils (Jarod Wilson)

* Fri Aug 14 2008 Karsten Hopp <karsten@redhat.com> 56-2
- fix warnings

* Fri Aug 14 2008 Karsten Hopp <karsten@redhat.com> 56-1
- update to version 56 to fix namespace problems for mount parameters

* Fri Aug 08 2008 Karsten Hopp <karsten@redhat.com> 53-1
- update to version 53
- drop verbosity from list of parameters passed to the mount command

* Sat Mar 08 2008 Karsten Hopp <karsten@redhat.com> 41-1
- update to 41

* Mon Feb 18 2008 Mike Halcrow <mhalcrow@us.ibm.com> 40-0
- Enable passwd_file option in openssl key module

* Wed Feb 13 2008 Mike Halcrow <mhalcrow@us.ibm.com> 39-0
- Fix include upstream

* Wed Feb 13 2008 Karsten Hopp <karsten@redhat.com> 38-1
- fix includes

* Mon Jan 14 2008 Karsten Hopp <karsten@redhat.com> 38-1
- update to version 38

* Fri Dec 21 2007 Jarod Wilson <jwilson@redhat.com> 37-1
- update to version 37

* Fri Dec 14 2007 Karsten Hopp <karsten@redhat.com> 32-2
- fix conflicts as our kernel has a ecryptfs backport

* Thu Dec 13 2007 Karsten Hopp <karsten@redhat.com> 32-1
- update to version 32

* Thu Nov 29 2007 Karsten Hopp <karsten@redhat.com> 30-2
- fix ia64 libdir
- build initial RHEL-5 version

* Thu Nov 29 2007 Karsten Hopp <karsten@redhat.com> 30-1
- build version 30

* Fri Oct 05 2007 Mike Halcrow <mhalcrow@us.ibm.com> - 30-0
- Bump to version 30. Several bugfixes. Key modules are overhauled
  with a more sane API.
* Wed Aug 29 2007 Fedora Release Engineering <rel-eng at fedoraproject dot org> - 18-1
- Rebuild for selinux ppc32 issue.

* Thu Jun 28 2007 Mike Halcrow <mhalcrow@us.ibm.com> - 18-0
- Bump to version 18 with an OpenSSL key module fix
* Thu Jun 21 2007 Kevin Fenzi <kevin@tummy.com> - 17-1
- Change kernel Requires to Conflicts
- Remove un-needed devel buildrequires
* Wed Jun 20 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 17-0
- Provide built-in fallback passphrase key module. Remove keyutils,
  openssl, and pam requirements (library dependencies take care of
  this). Include wrapped passphrase executables in file set.
* Fri Apr 20 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 15-1
- Change permission of pam_ecryptfs.so from 644 to 755.
* Thu Apr 19 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 15-0
- Fix mount option parse segfault. Fix pam_ecryptfs.so semaphore
  issue when logging in via ssh.
* Thu Mar 01 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 10-0
- Remove verbose syslog() calls; change key module build to allow
  OpenSSL module to be disabled from build; add AUTHORS, NEWS, and
  THANKS to docs; update Requires with variables instead of hardcoded
  name and version.
* Tue Feb 06 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 9-1
- Minor update in README, add dist tag to Release, add --disable-rpath
  to configure step, and remove keyutils-libs from Requires.
* Tue Jan 09 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 9-0
- Correct install directories for 64-bit; add support for xattr and
  encrypted_view mount options
* Tue Jan 02 2007 Mike Halcrow <mhalcrow@us.ibm.com>  - 8-0
- Introduce build support for openCryptoki key module.  Fix -dev build
  dependencies for devel package
* Mon Dec 11 2006 Mike Halcrow <mhalcrow@us.ibm.com>  - 7-0
- Initial package creation
